import $ from "jquery";
var VueCmd = {};
function install(Vue, option) {
    Vue.mixin({
        beforeCreate: function () {
            var options = this.$options;
            if (options.cmd) {
                this.$cmd = options.cmd;
            } else if (options.parent && options.parent.$cmd) {
                this.$cmd = options.parent.$cmd;
            }
        }
    });
}
var Cmd = function (option) {
    this.url = "api/";
    for (var key in option) {
        this[key] = option[key];
    }
}
Cmd.prototype.executetoken = function (data, callback) {
    var self = this;
    if (!data) data = {};
    var token = null;
    if (!data.accesstoken) {
        if (this.token) {
            token = this.token;
            data.accesstoken = token;
        } else if (!data.accesstoken) {
            token = localStorage.getItem("token");
            data.accesstoken = token;
        }
    }
    this.execute(data, function (err, result) {
        if (err == "loginfirst" && self.logincallback) {
            self.logincallback();
        } else {
            callback(err, result);
        }
    });
}
Cmd.prototype.execute = function (data, callback) {
    var self = this;
    var param = {
        type: "POST",
        url: self.url,
        data: data
    }
    param.url = self.url;
    if (data.url) {
        param.url = data.url
    }
    $.ajax(param).done(function (res) {
        console.log(res);
        if (!res) return callback("no res", null);
        try {
            res = JSON.parse(res);
        } catch (e) {
            return callback(res, null);
        }
        if (res.error) {
            return callback(res.error, null);
        }
        return callback(null, res.result);
    }).fail(function (err) {
        if (callback) {
            return callback(err, null);
        }
    });
}
Cmd.prototype.executefiletoken=function(data,callback) {
    var self = this;
    if (!data) return;
    var token = null;
    if (!data.has("accesstoken")) {
        if (this.token) {
            token = this.token;
            data.append("accesstoken",token);
        } else {
            token = localStorage.getItem("token");
            data.append("accesstoken",token);
        }
    }
    this.executeWithFile(data, function (err, result) {
        if (err == "loginfirst" && self.logincallback) {
            self.logincallback();
        } else {
            callback(err, result);
        }
    });    
}
Cmd.prototype.executeWithFile = function (data, callback) {
    var self = this;
    var url = self.url;
    if (data.url) {
        url = data.url;
    }
    $.ajax({
        type: "POST",
        url: url,
        data: data,
        processData: false,
        cache: false,
        contentType: false
    }).done(function (res) {
        console.log(res);
        if (!res) {
            return callback("no res", null);
        }
        try {
            res = JSON.parse(res);
        } catch (e) {
            return callback(res, null);
        }
        if (res.error) {
            return callback(res.error, null);
        }
        if (!res.result) {
            return callback("no result", null);
        }
        return callback(null, res.result);
    }).fail(function (err) {
        if (callback) {
            return callback(err, null);
        }
    });
}
export default {
    install: install,
    Cmd: Cmd
};